﻿#include <hmg.ch>

**************************************
FUNCTION EnableDragAndDrop ()
Local nEventIdx
* Create Public Array 
PUBLIC _HMG_DaD_Data [11]

CREATE EVENT PROCNAME _HMG_DragAndDrop() STOREINDEX nEventIdx
//EventProcessHMGWindowsMessage (nEventIdx, .T.)
//EventProcessAllHookMessage ( nEventIdx, .T. )
_HMG_DaD_DATA [1] := nEventIdx

RETURN
**************************************
FUNCTION DisableDragAndDrop ()
IF TYPE('_HMG_DaD_DATA') = "A" .AND. _HMG_DaD_DATA [1] <> Nil
	EventRemove ( _HMG_DaD_DATA [1] )
ENDIF
RELEASE _HMG_DaD_DATA
IF isWindowDefined(_HMD_Drag_Form_)
	DoMethod('_HMD_Drag_Form_' ,'Release')
ENDIF
RETURN 
*************
FUNCTION _HMG_DragAndDrop()
STATIC nLastMsg, aDragDATA, aCursorChng:={}
LOCAL  nHWnd := EventHWND ()
LOCAL  nMsg := EventMSG ()
LOCAL  nWParam := EventWPARAM ()
LOCAL  nLParam := EventLPARAM ()
LOCAL  nIndex := GetControlIndexByHandle ( nHWnd )
LOCAL  cCtrlType := IF( nIndex > 0, GetControlTypeByIndex (nIndex) , "") 
LOCAL  nGridRow , nGridCol , aGridCellData
LOCAL  cCtrlName := "" , cFormName := "", i, j, aValue := {}, aRecord := {}, Ret := Nil, xCellValue
LOCAL  hDC, BTstruct, hBitmap

IF !isWindowDefined(_HMD_Drag_Form_) //.and. .f.
	i := ASCAN ( _HMG_SYSDATA [ 69 ] , 'A' ) 
	IF i > 0 .AND.	_HMG_SYSDATA [ 68 ] [ i ]	//main window is already activated
		DEFINE WINDOW _HMD_Drag_Form_ ; 
		AT 0, 0 ;
		WIDTH 100 ;
		HEIGHT 25 ;
		WINDOWTYPE STANDARD ;
		TOPMOST;
		NOMINIMIZE;
		NOMAXIMIZE;
		NOSIZE;
		NOSYSMENU;
		NOCAPTION 
		
		@0,0 IMAGE _HMD_Drag_Image_ PICTURE "" WIDTH 0 HEIGHT 0 TRANSPARENT 

		END WINDOW
		SET WINDOW _HMD_Drag_Form_ TRANSPARENT TO OPAQUE
		DISABLE EVENT OF _HMD_Drag_Form_
	ENDIF
	RETURN Nil
ENDIF

IF VALTYPE(aDragDATA) == "A"
	IF ASCAN( aCursorChng, nHWnd ) == 0
		AADD( aCursorChng, nHWnd )
	ENDIF
	*SetWindowCursor (nHWnd, IF ( aDragDATA [1] == nHWnd, "HMG_DRAGUP", "HMG_DRAGDOWN" ) )	//change mouse cursor
	SetWindowCursor (nHWnd, IF ( HMG_ValidControlTypeDragAndDrop( cCtrlType ), IDC_UPARROW, IDC_NO ) )	//change mouse cursor
	IF isWindowDefined(_HMD_Drag_Form_)
		SetProperty('_HMD_Drag_Form_' , 'Row' , GetCursorPos()[ 1 ] + 5 )
		SetProperty('_HMD_Drag_Form_' , 'Col' , GetCursorPos()[ 2 ] + 5 )
	ENDIF

	
ELSEIF LEN(aCursorChng) > 0
	FOR EACH i IN aCursorChng
		SetWindowCursor ( i, IDC_ARROW)		//reastore all changed mouse cursor
	NEXT
	IF isWindowDefined(_HMD_Drag_Form_)
		DoMethod('_HMD_Drag_Form_' ,'Hide')
	ENDIF
	aCursorChng:={}
	HMG_Release_DaD()
ENDIF

IF !HMG_ValidControlTypeDragAndDrop( cCtrlType )
	IF nMsg == WM_MOUSEMOVE .AND. nWParam # MK_LBUTTON .AND. nWParam # MK_RBUTTON .AND. VALTYPE(aDragDATA) == "A"	//canceled drag
		IF isWindowDefined(_HMD_Drag_Form_)
			DoMethod('_HMD_Drag_Form_' ,'Hide')
		ENDIF
		HMG_Release_DaD()
		aDragDATA := Nil						//release drag data
		FOR EACH i IN aCursorChng
			SetWindowCursor ( i, IDC_ARROW)		//reastore all changed mouse cursor
		NEXT
		aCursorChng:={}
	ENDIF
	RETURN Nil
ELSE
	DO CASE
		//MouseDrag detect and not stored drag data
		CASE nMsg == WM_MOUSEMOVE .AND. nLastMsg == WM_MOUSEMOVE .AND. ( nWParam == MK_LBUTTON .OR. nWParam == MK_RBUTTON ) .AND. aDragDATA == Nil				
			GetControlNameByHandle (nHWnd, @cCtrlName, @cFormName)			
			DoMethod( cFormName, cCtrlName, "SetFocus")
			DO CASE
				CASE cCtrlType == "GRID"							//GRID
					aGridCellData := _GetGridCellData (nIndex)  		//_GetGridCellData (nIndex) /* { CellRowClicked, CellColClicked } */
					hBitmap := BT_BitmapCaptureClientArea (cFormName, ;
							aGridCellData [3] ,;	
							aGridCellData [4] ,;	
							IF(aGridCellData [5] > 100, 100, aGridCellData [5]) ,;
							IF(aGridCellData [6] > 25, 25, aGridCellData [6]) )
			
					nGridRow := aGridCellData [1]					//Row of Grid cell
					nGridCol := aGridCellData [2]					//Col of Grid cell
					IF  nGridRow > 0								//Dragged from not empty row	
						FOR i = 1 TO GetProperty(cFormName, cCtrlName, "ColumnCOUNT")
							AADD(aRecord, GetProperty(cFormName, cCtrlName, "CellEx", nGridRow, i ) )
						NEXT i
						AADD( aValue, aRecord )
						aRecord := {}
						xCellValue := GetProperty(cFormName, cCtrlName, "CellEx", nGridRow, nGridCol )
						
						aDragDATA := {nHWnd, ;
							aValue, ;
							xCellValue, ;
							{ cFormName,  cCtrlName }, ;
							{ nGridRow , nGridCol }, ;
							nWParam }			
							//store drag data:
							//[1] handle of grid "from" 
							//[2] row data
							//[3] cell data
							//[4] Form and Control from name
							//[5] cell dragged
							//[6] nWParam (Left OR Right Button Dragged)
					ENDIF
					
				CASE cCtrlType == "MULTIGRID"						//GRID MULTISELECT  GetSystemMetrics(7 /*SM_CXFIXEDFRAME*/)
				
					aGridCellData := _GetGridCellData (nIndex)  		//_GetGridCellData (nIndex) /* { CellRowClicked, CellColClicked } */
					hBitmap := BT_BitmapCaptureClientArea (cFormName, ;
							aGridCellData [3] ,;	
							aGridCellData [4] ,;	
							IF(aGridCellData [5] > 100, 100, aGridCellData [5]) ,;
							IF(aGridCellData [6] > 25, 25, aGridCellData [6]) )
							
					nGridRow := aGridCellData [1]					//Row of Grid cell
					nGridCol := aGridCellData [2]					//Col of Grid cell
					
					IF LEN( GetProperty(cFormName, cCtrlName, "VALUE")) == 0		//Not selected, drag one row
						IF  nGridRow > 0  							//Dragged from not empty row	
							FOR i = 1 TO GetProperty(cFormName, cCtrlName, "ColumnCOUNT")
								AADD( aRecord, GetProperty(cFormName, cCtrlName, "CellEx", nGridRow, i ) )
							NEXT i
							AADD( aValue, aRecord )
							aRecord := {}
							xCellValue := GetProperty(cFormName, cCtrlName, "CellEx", nGridRow, nGridCol )
						ENDIF
					ELSE
						FOR j = 1 TO LEN( GetProperty(cFormName, cCtrlName, "VALUE") )
							FOR i = 1 TO GetProperty(cFormName, cCtrlName, "ColumnCOUNT")
								AADD( aRecord, GetProperty(cFormName, cCtrlName, "CellEx", GetProperty(cFormName, cCtrlName, "VALUE") [j] , i ) )
							NEXT i
							AADD( aValue, aRecord )
							aRecord := {}
						NEXT j
						IF  nGridRow > 0
							xCellValue := GetProperty(cFormName, cCtrlName, "CellEx", nGridRow, nGridCol )		//real cell dragged
						ELSE
							xCellValue := GetProperty(cFormName, cCtrlName, "CellEx", GetProperty(cFormName, cCtrlName, "VALUE") [1], 1 )	//1-st cell of 1-st selected row
						ENDIF
					ENDIF
				
					IF LEN( aValue ) > 0
						aDragDATA := {nHWnd, ;
							aValue, ;
							xCellValue, ;
							{ cFormName,  cCtrlName }, ;
							{ nGridRow , nGridCol }, ;
							nWParam }			
							//store drag data:
							//[1] handle of grid "from" 
							//[2] row data
							//[3] cell data
							//[4] Form and Control from name
							//[5] cell dragged
							//[6] nWParam (Left OR Right Button Dragged)
					ELSE
						HMG_Release_DaD()
						aDragDATA := Nil			
						RETURN Nil
					ENDIF
							
			
				CASE cCtrlType == 'TEXT' .OR. cCtrlType == 'NUMTEXT' .OR. cCtrlType == 'MASKEDTEXT' .OR. cCtrlType == 'CHARMASKTEXT' .OR. cCtrlType == 'EDIT'						//TEXTBOX / EDITBOX
					IF  nWParam == MK_LBUTTON		//Left button not supported for this controls
						HMG_Release_DaD()
						aDragDATA := Nil	
						RETURN Nil
					ENDIF
				
					hBitmap := BT_BitmapCaptureClientArea (cFormName, ;
							GetProperty( cFormName, cCtrlName ,'Row')  , ;
							GetProperty( cFormName, cCtrlName ,'Col') ,;
							IF(GetProperty( cFormName, cCtrlName ,'Width') > 100, 100, GetProperty( cFormName, cCtrlName ,'Width')),;
							IF(GetProperty( cFormName, cCtrlName ,'Height') > 25, 25, GetProperty( cFormName, cCtrlName ,'Height')) )
					
					AADD(aValue, {GetProperty( cFormName, cCtrlName, "Value" )})
					aDragDATA := {nHWnd, ;
							aValue, ;
							aValue [1][1], ;
							{ cFormName,  cCtrlName }, ;
							Nil , ;
							nWParam }			
							//store drag data:
							//[1] handle of control "from" 
							//[2] value as array
							//[3] xvalue
							//[4] Form and Control from name
							//[5] Nil
							//[6] nWParam (Left OR Right Button Dragged)
							

				CASE cCtrlType == 'RICHEDIT' 				//EDITBOX
					IF  nWParam == MK_LBUTTON		//Left button not supported for this controls
						HMG_Release_DaD()
						aDragDATA := Nil			
						RETURN Nil
					ENDIF

					hBitmap := BT_BitmapCaptureClientArea (cFormName, ;
							GetProperty( cFormName, cCtrlName ,'Row')  , ;
							GetProperty( cFormName, cCtrlName ,'Col') ,;
							IF(GetProperty( cFormName, cCtrlName ,'Width') > 100, 100, GetProperty( cFormName, cCtrlName ,'Width')),;
							IF(GetProperty( cFormName, cCtrlName ,'Height') > 25, 25, GetProperty( cFormName, cCtrlName ,'Height')) )
							
					IF EMPTY(GetProperty( cFormName, cCtrlName, "GetSelectText" ))
						//Drag entire value
						AADD(aValue, { GetProperty( cFormName, cCtrlName, "Value" ) } )
					ELSE
						//Drag selected text
						AADD(aValue, { GetProperty( cFormName, cCtrlName, "GetSelectText" ) })
					ENDIF
					
					aDragDATA := {nHWnd, ;
							aValue, ;
							aValue [1][1], ;
							{ cFormName,  cCtrlName }, ;
							Nil , ;
							nWParam }			
							//store drag data:
							//[1] handle of control "from" 
							//[2] value
							//[3] GetSelectText
							//[4] Form and Control from name
							//[5] Nil
							//[6] nWParam (Left OR Right Button Dragged)
							
				
				CASE cCtrlType == 'LIST' .OR. cCtrlType == 'MULTILIST'			//LISTBOX
					IF  nWParam == MK_LBUTTON .OR. ;		//Left button not supported for this controls
						IF(cCtrlType == 'MULTILIST', LEN( GetProperty(cFormName, cCtrlName, "Value") ) == 0, GetProperty(cFormName, cCtrlName, "Value") == 0)		//no item selected 
						HMG_Release_DaD()
						aDragDATA := Nil			
						RETURN Nil
					ENDIF
					
					*hBitmap := BT_BitmapCaptureDesktop (GetCursorPos()[ 1 ] - 10 , GetCursorPos()[ 2 ] - 30 , 100 , 40)
					IF cCtrlType == 'MULTILIST' 
						FOR i = 1 TO LEN( GetProperty(cFormName, cCtrlName, "Value") ) 
							AADD(aValue, {GetProperty( cFormName, cCtrlName, "Item" , GetProperty(cFormName, cCtrlName, "Value") [i] ) } )
						NEXT i
					ELSE
						AADD(aValue, {GetProperty( cFormName, cCtrlName, "Item" , GetProperty( cFormName, cCtrlName, "Value" ) ) } )
					ENDIF
					
					aDragDATA := {nHWnd, ;
							aValue, ;
							aValue [1][1], ;
							{ cFormName,  cCtrlName }, ;
							Nil , ;
							nWParam }			
							//store drag data:
							//[1] handle of control "from" 
							//[2] array of selectet values
							//[3] first/alone selected value
							//[4] Form and Control from name
							//[5] Nil
							//[6] nWParam (Left OR Right Button Dragged)
					
					hBitmap := BT_BitmapCreateNew (100, LEN(aValue) * 18, {255,255,255})
					//BT_DrawText (hDC, Row, Col, cText, cFontName, nFontSize, aFontColor, aBackColor, nTypeText, nAlingText, nOrientation)
					hDC := BT_CreateDC (hBitmap, BT_HDC_BITMAP, @BTstruct)
					FOR i=1 TO LEN( aValue )
						BT_DrawText (hDC, ((i-1)*18 ) + 1 , 2, aValue [i][1] , "MS Shell Dlg", 9)
					NEXT i
					BT_DeleteDC (BTstruct)
							
			ENDCASE
			
			IF isWindowDefined(_HMD_Drag_Form_)
				SetProperty('_HMD_Drag_Form_' , 'Row' , GetCursorPos()[ 1 ] + 5)
				SetProperty('_HMD_Drag_Form_' , 'Col' , GetCursorPos()[ 2 ] + 5)
				//hDC := BT_CreateDC (hBitmap, BT_HDC_BITMAP, @BTstruct)
				//BT_DeleteDC (BTstruct)
				BT_HMGSetImage ('_HMD_Drag_Form_', '_HMD_Drag_Image_', hBitmap, .T.)
				SetProperty('_HMD_Drag_Form_' , 'WIDTH' , BT_BitmapWidth (hBitmap))
				SetProperty('_HMD_Drag_Form_' , 'HEIGHT' , BT_BitmapHeight (hBitmap))
				DoMethod('_HMD_Drag_Form_' ,'Show')
			ENDIF
			BT_BitmapRelease (hBitmap)
			
			RETURN 1

		//stored drag data and released left/right button
		CASE VALTYPE(aDragDATA) == "A" .AND. nMsg == IF( aDragDATA[6] == MK_LBUTTON, WM_LBUTTONUP, WM_RBUTTONUP )
			IF isWindowDefined(_HMD_Drag_Form_)
				DoMethod('_HMD_Drag_Form_' ,'Hide')
			ENDIF
			
			GetControlNameByHandle (nHWnd, @cCtrlName, @cFormName)
			
			aGridCellData := _GetGridCellData (nIndex)  			//_GetGridCellData (nIndex) /* { CellRowDropped, CellColDropped } */
			nGridRow := aGridCellData [1]						//Row of Grid cell
			nGridCol := aGridCellData [2]						//Col of Grid cell
		
			_HMG_DaD_DATA [2] := .T.						//is Drag&Drop
			_HMG_DaD_DATA [3] := aDragDATA [4] [1]			//FormName From
			_HMG_DaD_DATA [4] := aDragDATA [4] [2]			//ControlName From
			_HMG_DaD_DATA [5] := cFormName				//FormName To
			_HMG_DaD_DATA [6] := cCtrlName				//ControlName To
			_HMG_DaD_DATA [7] := aDragDATA [2]				//row data
			_HMG_DaD_DATA [8] := aDragDATA [3]				//cell data
			IF cCtrlType == "GRID" .OR. cCtrlType == "MULTIGRID"
				_HMG_DaD_DATA [9] := { nGridRow , nGridCol }	//Cell dropped
			ENDIF
			_HMG_DaD_DATA [10] := aDragDATA [5]			//Cell dragged
			_HMG_DaD_DATA [11] := aDragDATA [6] == MK_RBUTTON	//Dragged with Right Button
			
			IF ( cCtrlType == "GRID" .OR. cCtrlType == "MULTIGRID" ) .AND. _HMG_DaD_DATA [11] 
				Ret := Nil								//if dragged with Right Button process other event ex. context menu
				DoMethod( cFormName, cCtrlName, "SetFocus")
			ELSE
				Ret := 1									//stop processing other events
				_DoControlEventProcedure ( _HMG_SYSDATA [ 11 ] [nIndex] , nIndex )
			ENDIF
			HMG_Release_DaD()
			aDragDATA := Nil						//release drag data
			FOR EACH i IN aCursorChng
				SetWindowCursor ( i, IDC_ARROW)		//reastore all changed mouse cursor
			NEXT
			aCursorChng:={}
			RETURN Ret
		
		CASE nMsg == WM_MOUSEMOVE .AND. nWParam # MK_LBUTTON .AND. nWParam # MK_RBUTTON .AND. VALTYPE(aDragDATA) == "A"	//canceled drag
			IF isWindowDefined(_HMD_Drag_Form_)
				DoMethod('_HMD_Drag_Form_' ,'Hide')
			ENDIF
			HMG_Release_DaD()
			aDragDATA := Nil						//release drag data
			FOR EACH i IN aCursorChng
				SetWindowCursor ( i, IDC_ARROW)		//reastore all changed mouse cursor
			NEXT
			aCursorChng:={}
			RETURN 1
	
	ENDCASE
ENDIF
nLastMsg:=EventMSG()
RETURN NIL
*****************************************************
FUNCTION HMG_ValidControlTypeDragAndDrop( cCtrlType )
RETURN cCtrlType == 'GRID' .OR. cCtrlType == 'MULTIGRID' .OR. cCtrlType == 'EDIT' .OR. cCtrlType == 'LIST' .OR. ;
cCtrlType == 'MULTILIST' .OR. cCtrlType == 'RICHEDIT' .OR. cCtrlType == 'TEXT' .OR. cCtrlType == 'NUMTEXT' .OR. ;
cCtrlType == 'MASKEDTEXT' .OR. cCtrlType == 'CHARMASKTEXT'
*****************************************************
FUNCTION HMG_Is_DaD()
RETURN TYPE('_HMG_DaD_DATA') == 'A' .AND. _HMG_DaD_DATA [2] <> Nil .AND. _HMG_DaD_DATA [2]
*****************************************************
FUNCTION HMG_Release_DaD()
IF TYPE('_HMG_DaD_DATA') == 'A'
	_HMG_DaD_DATA [2] := .F.
	_HMG_DaD_DATA [3] := Nil
	_HMG_DaD_DATA [4] := Nil
	_HMG_DaD_DATA [5] := Nil
	_HMG_DaD_DATA [6] := Nil
	_HMG_DaD_DATA [7] := Nil
	_HMG_DaD_DATA [8] := Nil
	_HMG_DaD_DATA [9] := Nil
	_HMG_DaD_DATA [10] := Nil
	_HMG_DaD_DATA [11] := Nil
ENDIF
RETURN 
*****************************************************
FUNCTION HMG_DaD_Drag()
LOCAL cFormFrom := '', cControlFrom := ''
IF HMG_Is_DaD() .AND. _HMG_DaD_DATA [3] <> Nil .AND. _HMG_DaD_DATA [4] <> Nil
	cFormFrom    := _HMG_DaD_DATA [3]
	cControlFrom := _HMG_DaD_DATA [4]
ENDIF
RETURN {cFormFrom, cControlFrom}
*****************************************************
FUNCTION HMG_DaD_Drop()
LOCAL cFormTo := '', cControlTo := ''
IF HMG_Is_DaD() .AND. _HMG_DaD_DATA [5] <> Nil .AND. _HMG_DaD_DATA [6] <> Nil
	cFormTo    := _HMG_DaD_DATA [5]
	cControlTo := _HMG_DaD_DATA [6]
ENDIF
RETURN {cFormTo, cControlTo}
*****************************************************
FUNCTION HMG_DaD_Drag_Window()
RETURN HMG_DaD_Drag() [1]
*****************************************************
FUNCTION HMG_DaD_Drag_Control()
RETURN HMG_DaD_Drag() [2]
*****************************************************
FUNCTION HMG_DaD_Drop_Window()
RETURN HMG_DaD_Drop() [1]
*****************************************************
FUNCTION HMG_DaD_Drop_Control()
RETURN HMG_DaD_Drop() [2]
*****************************************************
FUNCTION HMG_DaD_DropCellPos()
LOCAL nRow := Nil, nCol := Nil
IF HMG_Is_DaD() .AND. TYPE('_HMG_DaD_DATA [9]') == 'A'
	nRow := _HMG_DaD_DATA [9] [1]
	nCol := _HMG_DaD_DATA [9] [2]
ENDIF
RETURN {nRow, nCol}
*****************************************************
FUNCTION HMG_DaD_DropCellRow()
RETURN HMG_DaD_DropCellPos() [1]
*****************************************************
FUNCTION HMG_DaD_DropCellCol()
RETURN HMG_DaD_DropCellPos() [2]
*****************************************************
FUNCTION HMG_DaD_DragCellPos()
LOCAL nRow := Nil, nCol := Nil
IF HMG_Is_DaD() .AND. TYPE('_HMG_DaD_DATA [10]') == 'A'
	nRow := _HMG_DaD_DATA [10] [1]
	nCol := _HMG_DaD_DATA [10] [2]
ENDIF
RETURN {nRow, nCol}
*****************************************************
FUNCTION HMG_DaD_DragCellRow()
RETURN HMG_DaD_DragCellPos() [1]
*****************************************************
FUNCTION HMG_DaD_DragCellCol()
RETURN HMG_DaD_DragCellPos() [2]
*****************************************************
FUNCTION HMG_DaD_Value()
LOCAL xValue := Nil
IF HMG_Is_DaD() 
	xValue := _HMG_DaD_DATA [7]
ENDIF
RETURN xValue
*****************************************************
FUNCTION HMG_DaD_CellValue()
LOCAL xValue := Nil
IF HMG_Is_DaD() 
	xValue := _HMG_DaD_DATA [8]
ENDIF
RETURN xValue
*****************************************************
FUNCTION HMG_Is_RButtonDaD()
RETURN TYPE('_HMG_DaD_DATA') == 'A' .AND. _HMG_DaD_DATA [11] <> Nil .AND. _HMG_DaD_DATA [11]